<?php

/*
 * @package RS-SITE
 * @copyright (c) 2013 Alexey Glumov aka Rio-Shaman (support@rio-shaman.ru)
 * @license GNU General Public License version 2; see LICENSE.txt
 *
 */
 

if(!defined('RS-SITE')) die();

class comment extends core
{
    /*инициализация объектов для работы данного класса*/
    function comment()
    {
        $this->core();
        $this->count = 0;
    }
    
    /* CASE : BROWSE */
    
    /* получаем все комментарии */
    function get_comment($fields)
    {
        if (empty($fields))
            $this->set_filter($fields);
        else
            if (!$this->save_date($fields))
                $this->set_filter($fields);

        $sql = "SELECT"
            ." c.comment_id as comment_id, c.comment_author as comment_author, c.comment_site as comment_site, c.comment_email as comment_email,"
            ." c.comment_text as comment_text, c.comment_publication as comment_publication, c.comment_parent as comment_parent, cnt.catalog_id as catalog_id,"
            ." c.content_id as content_id, c.comment_status as comment_status, m.map_alias as content_alias, m.map_parent as map_parent"
        ." FROM rs_comment c, rs_content cnt, rs_map m"
        ." WHERE 1=1"
            ." AND c.content_id=cnt.content_id"
            ." AND cnt.map_id=m.map_id"
            .( ($fields['status'] == 0) ? " AND c.comment_status = '0'" : ( ($fields['status'] == 1) ? " AND c.comment_status > '0'" : " AND c.comment_status >= '0'" ) )
            ." AND c.comment_publication BETWEEN '".$fields['start']."' AND '".$fields['end']."'"
            .( ($fields['email'] != '') ? " AND c.comment_email = '".$fields['email']."'" : '' );
            
        if (!$comments = $this->db->accept_select($sql))
            return array('filter' => $this->get_filter($fields));

        $this->change_date($comments);
        $this->get_dir($comments);

        //$comments = $this->get_tree($comments);

        return array('comments' => $comments, 'filter'    => $this->get_filter($fields));
    }

    function get_filter($fields)
    {
       $start = explode(' ', $fields['start']);
       $start = explode('-', $start[0]); 

       $end   = explode(' ', $fields['end']);
       $end   = explode('-', $end[0]);
               
       $result = array(
           'sday'         => $start[2],
           'smonth'       => $start[1],
           'syear'        => $start[0],
           'eday'         => $end[2],
           'emonth'       => $end[1],
           'eyear'        => $end[0],
           'status'       => $fields['status'],
           'email'        => $fields['email']
       );
        
        return $result;
    }
    
    /* заменяем даты на человекочитаемые */ 
    function change_date(&$comments)
    {
        foreach ($comments as $key => $comment)
            $comments[$key]['comment_publication'] = $this->tools->change_date($comment['comment_publication']);        
    }

    /* формируем ссылки на посты */
    function get_dir(&$comments)
    {
        foreach ($comments as $key => $comment)
        {
            $type = FALSE;
            
            if (!preg_match("/^.*?\.html$/", $comment['content_alias']))
                $type = TRUE;

            $comment['catalog_tree'] = $this->get_catalog_tree($comment['catalog_id']);
            
            if ($comment['catalog_tree'] === FALSE)
                $comment['catalog_tree'] = $comment['map_parent'];
                
            $path = array();
            $this->tools->get_parents_dir($comment['catalog_id'], $comment['catalog_tree'], $path);
            
            $comments[$key]['path'] = '/'
                .( (!empty($path)) ? implode('/', array_reverse($path)).'/' : '' )
                .$comment['content_alias'].( ($type === TRUE) ? '/' : '' )
                .'#comment_'.$comment['comment_id'];
        }
    }

    function get_catalog_tree($catalog_id)
    {
        foreach($GLOBALS['rssite']['cachecatalog'] as $tree => $catalog_array)
            foreach ($catalog_array as $catalog)
                if ($catalog_id == $catalog['id'])
                    return $tree;
                    
        return FALSE;
    }
    
    /* строим дерево */
    function get_tree($comments, $comment_parent = 0)
    {
        $result = array();
        
        foreach ($comments as $comment)
        {
            if ($comment['comment_parent'] == $comment_parent)
            {
                $comment['sub_comments'] = $this->get_tree($comments, $comment['comment_id']);
                $result[] = $comment;
            }
        }
        
        return $result;
    }
    
    /* получаю корректную дату и статус для выборки комментов */
    function set_filter(&$fields)
    {
        if (isset($_COOKIE['comment_filter']))
        {
            $filter = unserialize($_COOKIE['comment_filter']);
            
            $fields['start']    = $filter['start'];
            $fields['end']      = $filter['end'];
            $fields['status']   = $filter['status'];
            $fields['email']    = $filter['email'];
            
            return TRUE;
        }
        
        $fields['start']     = date('Y-m-d').' 00:00:00';
        $fields['end']       = date('Y-m-d').' 23:59:59';
        $fields['status']    = 2;
        $fields['email']     = '';
        
        return TRUE;
    }
    
    /* если присланный массив с фильтром не пустой, то необходимо его проверить и записать в куку */
    function save_date(&$fields)
    {
        if (!$this->tools->check_date($fields['start']))
            return FALSE;
            
        if (!$this->tools->check_date($fields['end']))
            return FALSE;
            
        if (!empty($fields['email']))
            if (!$this->tools->check_email($fields['email']))
                return FALSE;
        
        if ($fields['status'] < 0 OR $fields['status'] > 2)
            return FALSE;
        
        $fields['start']     = $fields['start'].' 00:00:00';
        $fields['end']       = $fields['end'].' 23:59:59';
        
        setcookie('comment_filter', serialize($fields), time()+60*60, '/');
        return TRUE;
    }

    /* CASE : EDIT */
    
    function edit_comment($fields)
    {
        $sql = "SELECT * FROM rs_comment WHERE comment_id='".$fields['comment_id']."'";
        
        if (!$comment = $this->db->accept_select($sql))
            die();
        
        $what = array(
            'comment_text'    => $fields['comment_text']
        );
        
        $this->db->accept_update($what, 'rs_comment', "comment_id='".$fields['comment_id']."'");
        die();
    }
    
    /* CASE : DELETE */
    
    function delete_comment($fields)
    {
        $sql = "SELECT content_num_comm FROM rs_content WHERE content_id='".$fields['content_id']."'";

        if (!$content = $this->db->accept_select($sql))
            die('no content');

        $this->delete_tree($fields['comment_id']);
            
        $count = $content[0]['content_num_comm'];

        $this->db->accept_update(array('content_num_comm' => $count - $this->count), 'rs_content', "content_id='".$fields['content_id']."'");
    }
    
    function delete_tree($comment_id)
    {
        $sql = "SELECT comment_status FROM rs_comment WHERE comment_id='".$comment_id."'";
        
        if (!$comment = $this->db->accept_select($sql))
            die('no comment');
        
        $sql = "SELECT comment_id FROM rs_comment WHERE comment_parent='".$comment_id."'";
        
        if ($comment_parent = $this->db->accept_select($sql))
            foreach($comment_parent as $parent)
                $this->delete_tree($parent['comment_id']);
        
        $sql = "DELETE FROM rs_comment WHERE comment_id='".$comment_id."'";
        
        $this->db->accept_delete($sql);
        
        if ($comment[0]['comment_status'] > 0)
            $this->count++;
    }
    
    /* CASE : STATUS */
    
    function change_status($fields)
    {
        $sql = "SELECT content_num_comm FROM rs_content WHERE content_id='".$fields['content_id']."'";

        if (!$content = $this->db->accept_select($sql))
            die('no content');

        $sql = "SELECT * FROM rs_comment WHERE comment_id='".$fields['comment_id']."'";

        if (!$comment = $this->db->accept_select($sql))
            die('no comment');        
        
        // обновляем статус комменатрия и статус пользователя
        $comment = $comment[0];
        $new_status = ($comment['comment_status'] == 0) ? 1 : 0;
        $this->db->accept_update(array('comment_status' => $new_status), 'rs_comment', "comment_id='".$fields['comment_id']."'");
        $this->db->accept_update(array('user_status' => $new_status), 'rs_user', "user_email='".$comment['comment_email']."'");
        
        // обновляем кол-во комментов в контенте        
        $count = ($new_status == 0) ? $content[0]['content_num_comm'] - 1 : $content[0]['content_num_comm'] + 1;
        $this->db->accept_update(array('content_num_comm' => $count), 'rs_content', "content_id='".$fields['content_id']."'");
        
        if ($new_status != 0 AND $comment['comment_parent'] != 0)
            $this->send_for_user($comment);
    }
    
    // отправка почты для юзера, если на его комментарий пришел ответ
    function send_for_user($comment)
    {
        // вытаскиваем мыло родителя
        $sql = "SELECT comment_email FROM rs_comment WHERE comment_id='".$comment['comment_parent']."'";
        
        if (!$comment_email = $this->db->accept_select($sql))
            return FALSE;
        
        $comment_email = $comment_email[0]['comment_email'];
        
        // вытаскиваем id пользователя чье мыло нашли выше
        $sql = "SELECT user_id FROM rs_user WHERE user_email='".$comment_email."'";
        
        if (!$user = $this->db->accept_select($sql))
            return FALSE;
            
        $user = $user[0];
        
        // делаем запрос для определения пути к комментарию
        $sql = "SELECT"
            ." cnt.catalog_id as catalog_id, m.map_alias as content_alias, m.map_parent as map_parent"
        ." FROM rs_comment c, rs_content cnt, rs_map m"
        ." WHERE 1=1"
            ." AND c.comment_id='".$comment['comment_id']."'"
            ." AND c.content_id=cnt.content_id"
            ." AND cnt.map_id=m.map_id";
        
        if (!$alias = $this->db->accept_select($sql))
            return FALSE;
        
        $alias = $alias[0];
        
        // создаем путь к комментарию

        $type = FALSE;
        if (!preg_match("/^.*?\.html$/", $alias['content_alias']))
            $type = TRUE;

        $alias['catalog_tree'] = $this->get_catalog_tree($alias['catalog_id']);
            
        if ($alias['catalog_tree'] === FALSE)
            $alias['catalog_tree'] = $alias['map_parent'];
            
        $path = array();
        $this->tools->get_parents_dir($alias['catalog_id'], $alias['catalog_tree'], $path);
        
        $path = '/'
            .( (!empty($path)) ? implode('/', array_reverse($path)) : '' ).'/'
            .$alias['content_alias'].( ($type === TRUE) ? '/' : '' )
            .'#comment_'.$alias['comment_id'];

        
        // формируем параметры для формироания письма
        $param = array(
            'user_id'    => $user['user_id'],
            'parser'    => array(
                'alias'   => 'usercomments',
                'msg'     => array(
                    'SITE'       => $_SERVER['HTTP_HOST'],
                    'NAME'       => $comment['comment_author'],
                    'MESSAGE'    => nl2br($comment['comment_text']),
                    'LINK'       => 'http://'.$_SERVER['HTTP_HOST'].$path,
                    'CMS'        => CMS.' v'.VERSION
                )
            )
        );

        // отправляем почту
        $this->sendmail->get_param($param);
    }
}
?>