<?php

/*
 * @package RS-SITE
 * @copyright (c) 2013 Alexey Glumov aka Rio-Shaman (support@rio-shaman.ru)
 * @license GNU General Public License version 2; see LICENSE.txt
 *
 */
 

if(!defined('RS-SITE')) die();

class sizeIMG extends core
{
    /*инициализация объектов для работы данного класса*/
    function sizeIMG()
    {
        $this->core();
        $this->max = 700;
    }
    
    function set_img($fields, $g)
    {
        if (!preg_match("/^http.*?$/", $fields['path']))
            $fields['path'] = (!preg_match("/^[\/]{1}.*?$/", $fields['path'])) ? $GLOBALS['rssite']['cfg']['server_root'].$fields['path'] : 'http://'.$_SERVER['HTTP_HOST'].$fields['path'];
        
        if (!$img_info = @getimagesize($fields['path']))
            return FALSE;
        
        $w        = (!isset($fields['width']))  ? 0 : ( ($fields['width'] <= $img_info[0])  ? $fields['width']  : 0 );
        $h        = (!isset($fields['height'])) ? 0 : ( ($fields['height'] <= $img_info[1]) ? $fields['height'] : 0 );

        /*массив с поддерживаемыми миме типами*/
        
        $formats_array = array(
            'image/jpeg',
            'image/gif',
            'image/png',
            'image/bmp'
        );
        
        /*проверка поддержки открываемого изображения*/
        
        if (!in_array($img_info['mime'], $formats_array))
            return FALSE;
        
        /*создаем корректное пустое изображение... поределяется по миме типу*/
        
        switch(trim($img_info['mime']))
        {
            case 'image/jpeg':
                $instant = imagecreatefromjpeg($fields['path']);
                break;
            case 'image/gif':
                $instant = imagecreatefromgif($fields['path']);
                break;
            case 'image/png':
                $instant = imagecreatefrompng($fields['path']);
                break;
            case 'image/bmp':
                $instant = imagecreatefrombmp($fields['path']);
                break;
        }
        
        /* определяем пропорциональную ширину и высоту, если они жестко не указаны */
        
        if ($w == 0)
            $w = ($img_info[0] > $this->max) ? $this->max : $img_info[0];
        
        if ($h == 0)
        {
            if ($img_info[0] > $img_info[1])
                $h = intval($w / ($img_info[0] / $img_info[1]));
            
            if ($img_info[0] < $img_info[1])
                $h = intval($w * ($img_info[1] / $img_info[0]));
            
            if ($img_info[0] == $img_info[1])
                $h = $w;
        }
        
        /* определяем на сколько необходимо обрезать изображение */
        /* по умолчанию координаты обрезки фото - нули */
        $x = 0;
        $y = 0;
        
        /* если включено обрезание изображения, и ширина и высота равны, т.е. создаем привью */
        
        if ($g == TRUE AND $w == $h)
        {
            $x = ($img_info[0] > $img_info[1]) ? intval(($img_info[0] - $img_info[1]) / 2) : 0;
            $y = ($img_info[0] < $img_info[1]) ? intval(($img_info[1] - $img_info[0]) / 2) : 0;
        }

        $real_w = $img_info[0] - ($x * 2);
        $real_h = $img_info[1] - ($y * 2);
                    
        $new_img = imagecreatetruecolor($w, $h);
        imagecopyresampled($new_img,$instant,0,0,$x,$y,$w,$h,$real_w,$real_h);
        
        /* вызов коректной функции создания изображения (определение по миме типу) */
        switch(trim($img_info['mime']))
        {
            case 'image/jpeg':
                header("content-type: image/jpeg");
                echo imagejpeg($new_img, '', 100);
                break;
            case 'image/png':
                header("content-type: image/png");
                echo  imagepng($new_img);
                break;
            case 'image/gif':
                header("content-type: image/gif");
                echo  imagegif($new_img);
                break;
            case 'image/bmp':
                header("content-type: image/bmp");
                echo  imagewbmp($new_img);
                break;
        }
        
        imagedestroy($new_img);
        imagedestroy($instant);
        
        return TRUE;
    }
}
?>