<?php

/*
 * @package RS-SITE
 * @copyright (c) 2013 Alexey Glumov aka Rio-Shaman (support@rio-shaman.ru)
 * @license GNU General Public License version 2; see LICENSE.txt
 *
 */

if(!defined('RS-SITE')) die();

class profile extends core
{
	/*инициализация объектов для работы данного класса*/
	function profile($value)
	{
		$this->core();
        $this->type = $value['type'];
        $this->page = (isset($_GET['page'])) ? $this->tools->clear_int($_GET['page']) : 1;
        $this->rc   = $value['rc'];
	}
    
    /* CASE : BROWSE */
    
    function show_list_user()
    {
		// получаем инфу о навигации
        $param = array(
            'modul'    => 'user',// вообще это имя таблицы без приставки rs_
            'rc'       => $this->rc,
            'page'     => $this->page
        );
        
        $navigation = $this->navigation->set_navigation($param);
        
        $sql = "SELECT * FROM rs_user"
             ." ORDER BY user_id DESC"
             ." LIMIT ".$navigation['navigation']['rc']." OFFSET ".$navigation['navigation']['offset'];
        
        if (!$users = $this->db->accept_select($sql))
            return array();
        
        $access_array = array(
            0    => 'Гость',
            1    => 'Пользователь',
            2    => 'Оператор',
            3    => 'Администратор',
            4    => 'Разработчик'
        );
        
        $status = $GLOBALS['rssite']['cfg']['profile']['status'];
        
        $status_array = array(
            0    => $status[0],
            1    => $status[1],
            2    => $status[2],
            3    => $status[3],
            4    => $status[4],
            5    => $status[5]
        );
        
        foreach ($users as $key => $user)
        {
            $users[$key]['user_access_name'] = $access_array[$user['user_access']];
            $users[$key]['user_status_name'] = $status_array[$user['user_status']];
        }
            
        return array('users' => $users, 'navigation' => $navigation['navigation']);
    }
    
    /* CASE : ADD */
    
    function show_form($fields)
    {
        if (!empty($fields))
            return $fields;
            
        return array();
    }

    function add_user($fields)
    {
        // статус
        if ($fields['user_status'] > 5 OR $fields['user_status'] < 0)
            return $this->get_error($fields, 0, 'Нет прав');
        
        // доступ    
        if ($fields['user_access'] > 3 OR $fields['user_access'] < 0)
            return $this->get_error($fields, 1, 'Нет прав');
        
        // имя
        if (empty($fields['user_name']))
            return $this->get_error($fields, 2, 'Пустое поле');

        // логин
        if (empty($fields['user_login']))
            return $this->get_error($fields, 3, 'Пустой логин');
            
        if (!$this->tools->check_login($fields['user_login']))
            return $this->get_error($fields, 4, 'Неверный логин');

        if ($this->exist_login($fields['user_login']))
            return $this->get_error($fields, 5, 'Такой логин уже существует');
        
        // пароль    
        if (empty($fields['user_password']))
            return $this->get_error($fields, 9, 'Пустое поле');
            
        if (!$this->tools->check_password($fields['user_password']))
            return $this->get_error($fields, 11, 'Неверный пароль');

        if ($fields['user_password'] != $fields['user_repeat'])
            return $this->get_error($fields, 10, 'Пароли не совпадают');
        
        $password = md5(md5($GLOBALS['rssite']['cfg']['sole']).md5($fields['user_password']));
 
         // мыло
        if (empty($fields['user_email']))
            return $this->get_error($fields, 6, 'Пустое поле');

        if (!$this->tools->check_email($fields['user_email']))
            return $this->get_error($fields, 7, 'Неверный email');
            
        if ($this->exist_email($fields['user_email']))
            return $this->get_error($fields, 8, 'Такая почта уже есть в БД');
        
        $fields['user_more'] = 0;
        
        if ($additional = $this->tools->get_object('additional'))
            $fields['user_more'] = $additional->add_value($fields['a_fields']);
            
        $what = array(
            'user_name'        => $fields['user_name'],
            'user_login'       => $fields['user_login'],
            'user_password'    => $password,
            'user_more'        => $fields['user_more'],
            'user_email'       => $fields['user_email'],
            'user_status'      => $fields['user_status'],
            'user_access'      => $fields['user_access'],
            'user_hash'        => ''
        );
        
        if(!$this->db->accept_insert($what, 'rs_user'))
            return $this->get_error($fields, 12, 'Произошла системная ошибка');
        
        $this->tools->move_to("/admin/".$this->type."/");        
    }    
    /* CASE : EDIT */

    function get_edit_form($user_id)
    {
        $sql = "SELECT * FROM rs_user WHERE user_id='".$user_id."'";
        
        if (!$user = $this->db->accept_select($sql))
            return array();
            
        $user = $user[0];
        
        return $user;
    }
    
    function edit_profile($fields)
    {
        // статус
        if ($fields['user_status'] > 5 OR $fields['user_status'] < 0)
            return $this->get_error($fields, 0, 'Нет прав');
        
        // доступ
        if ($GLOBALS['rssite']['user']['user_access'] < $fields['user_access'])
            return $this->get_error($fields, 1, 'Нет прав');

        // имя
        if (empty($fields['user_name']))
            return $this->get_error($fields, 2, 'Пустое поле');

        // логин
        if (empty($fields['user_login']))
            return $this->get_error($fields, 3, 'Пустой логин');
            
        if (!$this->tools->check_login($fields['user_login']))
            return $this->get_error($fields, 4, 'Неверный логин');

        // пароль
        if (!empty($fields['user_password']))
        {
            if ($fields['user_password'] != $fields['user_repeat'])
                return $this->get_error($fields, 7, 'Пароли не совпадают');
            
            if (!$this->tools->check_password($fields['user_password']))
                return $this->get_error($fields, 8, 'Неверный пароль');;
            
            $password = md5(md5($GLOBALS['rssite']['cfg']['sole']).md5($fields['user_password']));
        }

        // мыло
        if (empty($fields['user_email']))
            return $this->get_error($fields, 5, 'Пустое поле');

        if (!$this->tools->check_email($fields['user_email']))
            return $this->get_error($fields, 6, 'Неверный email');

        $sql = "SELECT user_access, user_login, user_email FROM rs_user WHERE user_id='".$fields['user_id']."'";

        if (!$user = $this->db->accept_select($sql))
            return $this->get_error($fields, 9, 'Произошла системная ошибка');
            
        $user = $user[0];

        if ($fields['user_email'] != $user['user_email'])
            if ($this->exist_email($fields['user_email']))
                return $this->get_error($fields, 10, 'Такая почта уже есть в БД');
        
        if ($fields['user_login'] != $user['user_login'])
            if ($this->exist_login($fields['user_login']))
                return $this->get_error($fields, 11, 'Такой логин уже существует');

        if ($GLOBALS['rssite']['user']['user_access'] < $user['user_access'])
            return $this->get_error($fields, 12, 'Произошла системная ошибка');
        
        $fields['user_access'] = ($user['user_access'] == 4) ? 4 : $fields['user_access'];
        
        if ($additional = $this->tools->get_object('additional'))
            $additional->edit_value($fields['a_fields'], $fields['user_id']);
        
        $what = array(
            'user_name'        => $fields['user_name'],
            'user_login'       => $fields['user_login'],
            'user_email'       => $fields['user_email'],
            'user_status'      => $fields['user_status'],
            'user_access'      => $fields['user_access']
        );
        
        if (isset($password))
            $what['user_password'] = $password;
        
        $this->db->accept_update($what, 'rs_user', "user_id='".$fields['user_id']."'");
        
        $this->tools->move_to("/admin/".$this->type."/");
    }

    /* CASE : DELETE */

    function delete_profile($profile_id)
    {
		$sql = "SELECT user_access FROM rs_user WHERE user_id='".$profile_id."'";
		
		if (!$profile = $this->db->accept_select($sql))
			return FALSE;

        $profile = $profile[0];

        if ($GLOBALS['rssite']['user']['user_access'] < $profile['user_access'])
            die();
		
		$sql = "DELETE FROM rs_user WHERE user_id='".$profile_id."'";
		
		$this->db->accept_delete($sql);
        
        die();
    }
        
    /* РАЗНОЕ */
    
    /* проверка существования логина */
    function exist_login($user_login)
    {
        $sql = "SELECT * FROM rs_user WHERE user_login='".$user_login."'";
        
        if ($user = $this->db->accept_select($sql))
            return TRUE;
            
        return FALSE;
    }

    /* проверка существования мыла */
    function exist_email($user_email)
    {
        $sql = "SELECT * FROM rs_user WHERE user_email='".$user_email."'";
        
        if ($user = $this->db->accept_select($sql))
            return TRUE;
            
        return FALSE;        
    }
    
    /* ERROR */
    
    function get_error($fields, $key, $error)
    {
        $fields['error'][$key] = $error;
        
        return $fields;
    }
}
?>