<?php

/*
 * @package RS-SITE
 * @copyright (c) 2013 Alexey Glumov aka Rio-Shaman (support@rio-shaman.ru)
 * @license GNU General Public License version 2; see LICENSE.txt
 *
 */
 

if(!defined('RS-SITE')) die();

class contact extends core
{
    function contact()
    {
        $this->core();
        $this->user_id    = (int)$GLOBALS['rssite']['user']['user_id'];
    }
    
    function send_message(&$fields)
    {
        // принудительно заменяем некоторые данные пользователя, если тот аторизован
        $this->init_user($fields);
        
        // проверка имени
        if (empty($fields['contact_author']))
        {
            $fields['error'][0] = 'Поле не должно быть пустым';
            return $fields;
        }

        // проверка мыла
        if (empty($fields['contact_email']))
        {
            $fields['error'][1] = 'Поле не должно быть пустым';
            return $fields;
        }        

        if (!$this->tools->check_email($fields['contact_email']))
        {
            $fields['error'][2] = 'Некорректный электронный ящик';
            return $fields;
        }
        
        // проверка темы
        if (empty($fields['contact_subject']))
        {
            $fields['error'][3] = 'Поле не должно быть пустым';
            return $fields;
        }

        // проверка текста
        if (empty($fields['contact_text']))
        {
            $fields['error'][4] = 'Поле не должно быть пустым';
            return $fields;
        }

        // проверяем капчу
        if ($this->user_id <= 0)
        {
            $sole         = $GLOBALS['rssite']['cfg']['sole'];
            $session_name = 'contact_'.$fields['content_id'];
            session_start();
            
            if (empty($fields['contact_code']))
            {
                $fields['error'][5] = 'Вы не подтвердили, что Вы человек';
                return $fields; 
            }                
            
            if (!isset($_SESSION[$session_name]))
            {
                $fields['error'][7] = 'Системная ошибка';
                return $fields;   
            }
            
            if ($_SESSION[$session_name] != md5($sole.$fields['contact_code']))
            {
                $fields['error'][6] = 'Вы выбрали не ту картинку';
                return $fields;                 
            }
        }

        $param = array(
            'access'    => 'feedback',
            'parser'    => array(
                'alias'   => 'feedback',
                'msg'     => array(
                    'SITE'       => $_SERVER['HTTP_HOST'],
                    'USER'       => $fields['contact_author'],
                    'EMAIL'      => $fields['contact_email'],
                    'DATATIME'   => $this->tools->get_now_date(),
                    'SUBJECT'    => $fields['contact_subject'],
                    'MESSAGE'    => nl2br($fields['contact_text']),
                    'CMS'        => CMS.' v'.VERSION
                )
            )
        ); 
        
        $this->sendmail->get_param($param);
        
        $this->tools->move_to('/contact/?event=done');
            
        return FALSE;
    }
    
    // если пользователь авторизован то принудительно перезаписываем некоторые присланные данные
    function init_user(&$fields)
    {
        if ($this->user_id <= 0)
            return FALSE;
        
        $fields['contact_author'] = $GLOBALS['rssite']['user']['user_name'];
        $fields['contact_email']  = $GLOBALS['rssite']['user']['user_email'];
            
        return TRUE;
    }
}
?>