<?php

/*
 * @package RS-SITE
 * @copyright (c) 2013 Alexey Glumov aka Rio-Shaman (support@rio-shaman.ru)
 * @license GNU General Public License version 2; see LICENSE.txt
 *
 */
 

if(!defined('RS-SITE')) die();

class profile extends core
{
    /*инициализация объектов для работы данного класса*/
    public function profile($value)
    {
        $this->core();
        
        $GLOBALS['rssite']['cfg']['meta']['two']['meta_title'] = $this->tools->get_caption();
    }
    
    /* CASE : BROWSE */
    
    public function getDetail()
    {
        $status = $GLOBALS['rssite']['cfg']['profile']['status'];

        $user                      = $GLOBALS['rssite']['user'];
        $user['user_status_name']  = $status[$user['user_status']];
            
        return $user;
    }
    
    /* CASE: CHANGE-PASSWORD */
    
    public function changePassword(&$fields)
    {
        // проверяем старый пароль
        if (empty($fields['user_oldpassword'])) {
            $fields['error'] = 'oldpassword.empty';
            return FALSE;
        }
        
        // проверяем пользователя по паролю и ID
        $user_id     = $GLOBALS['rssite']['user']['user_id'];
        $oldPassword = md5(md5($GLOBALS['rssite']['cfg']['sole']).md5($fields['user_oldpassword']));
        
        $sql = ""
            ."SELECT"
                ." user_id"
            ." FROM"
                ." rs_user"
            ." WHERE"
                ."     user_id         = '".$user_id."'"
                ." AND user_password   = '".$oldPassword."'"
        ;
        
        if (!$this->db->accept_select($sql)) {
            $fields['error'] = 'oldpassword.wrong';
            return FALSE;
        }
        
        // проверяем новый пароль
        if (empty($fields['user_password'])) {
            $fields['error'] = 'password.empty';
            return FALSE;
        }
        
        if (!$this->tools->check_password($fields['user_password'])) {
            $fields['error'] = 'password.wrong';
            return FALSE;
        }

        if ($fields['user_password'] != $fields['user_repeat']) {
            $fields['error'] = 'password.repeat';
            return FALSE;
        }
        
        $password = md5(md5($GLOBALS['rssite']['cfg']['sole']).md5($fields['user_password']));
        
        $what = array(
            'user_password'    => $password
        );
        
        $this->db->accept_update($what, 'rs_user', "user_id='".$user_id."'");
        
        $this->tools->move_to("/profile/");
    }
    
    /* CASE : CONTACTS */

    public function getEditForm(&$fields)
    {
        if (!empty($fields))
            return $fields;
        
        // получение системных данных
        $user_id = $GLOBALS['rssite']['user']['user_id'];
        
        $sql = ""
            ."SELECT"
                ." user.user_id                    AS user_id,"
                ." user.user_name                  AS user_name,"
                ." user.user_email                 AS user_email,"
                
                ." fields.field_site               AS field_site"
            ." FROM"
                ." rs_user                         user,"
                ." rs_profile_additional_fields    fields"
            ." WHERE"
                ."     user.user_id                = '".$user_id."'"
                ." AND fields.group_id             = user.user_more"
        ;
        
        if (!$user = $this->db->accept_select($sql))
            $this->tools->not_found();

        return $user[0];
    }
    
    public function editProfile(&$fields)
    {
        $user_id = $GLOBALS['rssite']['user']['user_id'];
        
        // Обновляем системные данные
        
        // имя
        if (empty($fields['user_name'])) {
            $fields['error'] = 'name.empty';
            return FALSE;
        }
        
        // мыло
        if (empty($fields['user_email'])) {
            $fields['error'] = 'email.empty';
            return FALSE;
        }

        if (!$this->tools->check_email($fields['user_email'])) {
            $fields['error'] = 'email.wrong';
            return FALSE;
        }

        $sql = "SELECT user_email, user_more FROM rs_user WHERE user_id = '".$user_id."'";
        
        if (!$user = $this->db->accept_select($sql))
            $this->tools->not_found();
        
        if ($user[0]['user_email'] != $fields['user_email'])
            if ($this->exist_email($fields['user_email'])) {
                $fields['error'] = 'email.exist';
                return FALSE;
            }
        
        // проверяем сайт
        if (!$this->tools->check_site($fields['field_site'])) {
            $fields['error'] = 'site.wrong';
            return FALSE;
        }

        $what = array(
            'user_name'        => $fields['user_name'],
            'user_email'       => $fields['user_email']
        );

        $this->db->accept_update($what, 'rs_user', "user_id='".$user_id."'");
        
        // Обновляем доп данные
            
        $what = array(
            'field_site'    => $fields['field_site']
        );
        
        $this->db->accept_update($what, 'rs_profile_additional_fields', "group_id = '".$user[0]['user_more']."'");
        
        $this->tools->move_to("/profile/");
    }

    /* РАЗНОЕ */

    /* проверка существования мыла */
    private function exist_email($user_email)
    {
        $sql = "SELECT * FROM rs_user WHERE user_email='".$user_email."'";
        
        if ($user = $this->db->accept_select($sql))
            return TRUE;
            
        return FALSE;        
    }
}
?>