<?php

/*
 * @package RS-SITE
 * @copyright (c) 2013 Alexey Glumov aka Rio-Shaman (support@rio-shaman.ru)
 * @license GNU General Public License version 2; see LICENSE.txt
 *
 */
 

if(!defined('RS-SITE')) die();

class registration extends core
{
    function registration($value)
    {
        $this->core();

        // выводим доп мета-теги
        $GLOBALS['rssite']['cfg']['meta']['two']['meta_title'] = $this->tools->get_caption();
    }
    
    /* CASE: ENABLE */
    
    // регистрация пользователя
    public function registrationUser(&$fields)
    {
        // имя
        if (empty($fields['user_name'])) {
            $fields['error'] = 'name.empty';
            return FALSE;
        }

        // логин
        if (empty($fields['user_login'])) {
            $fields['error'] = 'login.empty';
            return FALSE;
        }
            
        if (!$this->tools->check_login($fields['user_login'])) {
            $fields['error'] = 'login.wrong';
            return FALSE;
        }

        if ($this->exist_login($fields['user_login'])) {
            $fields['error'] = 'login.exist';
            return FALSE;
        }
        
        // email
        if (empty($fields['user_email'])) {
            $fields['error'] = 'email.empty';
            return FALSE;
        }
        
        if (!$this->tools->check_email($fields['user_email'])) {
            $fields['error'] = 'email.wrong';
            return FALSE;
        }
        
        if ($this->exist_email($fields['user_email'])) {
            $fields['error'] = 'email.exist';
            return FALSE;
        }
        
        // пароль    
        if (empty($fields['user_password'])) {
            $fields['error'] = 'password.empty';
            return FALSE;
        }
            
        if (!$this->tools->check_password($fields['user_password'])) {
            $fields['error'] = 'password.wrong';
            return FALSE;
        }

        if ($fields['user_password'] != $fields['user_repeat']) {
            $fields['error'] = 'password.repeat';
            return FALSE;
        }
        
        $password     = md5(md5($GLOBALS['rssite']['cfg']['sole']).md5($fields['user_password']));
        $hash         = md5(md5($GLOBALS['rssite']['cfg']['sole']).md5($fields['user_login']).md5($fields['user_password']).md5(time()));
        
        $what = array(
            'field_site' => ''
        );
        
        $fields['user_more'] = $this->db->accept_insert($what, 'rs_profile_additional_fields', TRUE);
            
        $what = array(
            'user_name'        => $fields['user_name'],
            'user_login'       => $fields['user_login'],
            'user_password'    => $password,
            'user_more'        => $fields['user_more'],
            'user_email'       => $fields['user_email'],
            'user_status'      => 0,
            'user_access'      => 0,
            'user_hash'        => $hash
        );
        
        $user_id = $this->db->accept_insert($what, 'rs_user', TRUE);
        
        // формируем параметры для формироания письма
        $param = array(
            'user_id'   => $user_id,
            'parser'    => array(
                'alias'   => 'registrationcode',
                'msg'     => array(
                    'SITE'       => $_SERVER['HTTP_HOST'],
                    'LINK'       => 'http://'.$_SERVER['HTTP_HOST'].'/registration/confirm/?event=send&key='.$hash,
                    'CMS'        => CMS.' v'.VERSION
                )
            )
        );
        
        // отправляем почту
        $this->sendmail->get_param($param);
        
        $this->tools->move_to("/registration/confirm/");
    }
    
    /* CONFIRM */
    public function confirmUser($key)
    {
        // проверяем пользователя с таким ключом
        $sql = "SELECT user_id, user_login FROM rs_user WHERE user_hash = '".$key."'";
        
        if (!$user = $this->db->accept_select($sql))
            $this->tools->not_found();
        
        $user = $user[0];
        
        // записываем новый статус в БД
        $what = array(
            'user_status' => 1,
            'user_hash'     => ''
        );
        
        $this->db->accept_update($what, 'rs_user', "user_id='".$user['user_id']."'");
        
        // формируем параметры для формироания письма
        $param = array(
            'user_id'   => $user['user_id'],
            'parser'    => array(
                'alias'   => 'registrationdone',
                'msg'     => array(
                    'SITE'       => $_SERVER['HTTP_HOST'],
                    'LOGIN'      => $user['user_login'],
                    'CMS'        => CMS.' v'.VERSION
                )
            )
        );

        // отправляем почту
        $this->sendmail->get_param($param);
        $this->tools->move_to('/registration/done/');
    }

    /* РАЗНОЕ */
    
    /* проверка существования логина */
    function exist_login($user_login)
    {
        $sql = "SELECT * FROM rs_user WHERE user_login='".$user_login."'";
        
        if ($user = $this->db->accept_select($sql))
            return TRUE;
            
        return FALSE;
    }

    /* проверка существования мыла */
    function exist_email($user_email)
    {
        $sql = "SELECT * FROM rs_user WHERE user_email='".$user_email."'";
        
        if ($user = $this->db->accept_select($sql))
            return TRUE;
            
        return FALSE;        
    }
}
?>